/*
**  ComponentJS -- Component System for JavaScript <http://componentjs.com>
**  Copyright (c) 2009-2013 Ralf S. Engelschall <http://engelschall.com>
**
**  This Source Code Form is subject to the terms of the Mozilla Public
**  License, v. 2.0. If a copy of the MPL was not distributed with this
**  file, You can obtain one at http://mozilla.org/MPL/2.0/.
*/

(function(l,u,p){var c=function(){},e=function(){return c.hook("ComponentJS:lookup","pass",c.lookup.apply(l,arguments))};e.pattern={};var q;q=void 0;var n=null;e.symbol=function(a){null!==n&&(l[n]=q);"undefined"===typeof a||""===a?n=null:(n=a,q=l[n],l[n]=e);return e};e.ns=function(a,b){if("string"!==typeof a||""===a)throw"invalid namespace path";var c=a.split("."),f=c.length;"undefined"!==typeof b&&f--;for(var g=0,e=l;g<f;)"undefined"===typeof e[c[g]]&&(e[c[g]]={}),e=e[c[g++]];"undefined"!==typeof b&&
(e=e[c[g]]=b);return e};e.version={major:0,minor:9,micro:6,date:20130225};c.exception=function(a,b){var c;0<e.debug()&&"object"===typeof l.console&&("function"===typeof l.console.trace?l.console.trace():"undefined"!==typeof l.printStackTrace&&"function"===typeof l.console.log&&(c=l.printStackTrace(),l.console.log(c.join("\n"))));return Error("[ComponentJS]: ERROR: "+a+": "+b)};c.log=function(a){c.hook("ComponentJS:log","or",a)||("undefined"!==typeof l.console&&"undefined"!==typeof l.console.log?l.console.log("[ComponentJS]: "+
a):"undefined"!==typeof l.Titanium&&("undefined"!==typeof l.Titanium.API&&"function"===typeof l.Titanium.API.log)&&l.Titanium.API.log("[ComponentJS]: "+a))};var r=9;e.debug=function(a,b){if(0===arguments.length)return r;if(1===arguments.length)r=a;else if(a<=r){for(var d="",f=1;f<a;f++)d+="    ";c.log("DEBUG["+a+"]: "+d+b)}};e.nop=function(){};c.annotation=function(a,b,c){var f=null;b="__ComponentJS_"+b+"__";"undefined"!==typeof a&&null!==a&&("undefined"!==typeof a[b]&&(f=a[b]),"undefined"!==typeof c&&
(null!==c?a[b]=c:delete a[b]));return f};c.isdefined=function(a){return"undefined"!==typeof a};c.isown=function(a,b){var c=Object.hasOwnProperty.call(a,b);if("constructor"===b||"prototype"===b)c=c&&Object.propertyIsEnumerable.call(a,b),-1!==a[b].toString().indexOf("[native code]")&&(c=!1);return c};c.istypeof=function(a){var b=typeof a;"object"===b?null===a?b="null":"[object String]"===Object.prototype.toString.call(a)?b="string":"[object Number]"===Object.prototype.toString.call(a)?b="number":"[object Boolean]"===
Object.prototype.toString.call(a)?b="boolean":"[object Function]"===Object.prototype.toString.call(a)?b="function":"[object Array]"===Object.prototype.toString.call(a)?b="array":null!==c.annotation(a,"type")&&(b=c.annotation(a,"type")):"function"===b&&null!==c.annotation(a,"type")&&(b=c.annotation(a,"type"));return b};var s=/[\\\"\x00-\x1f\x7f-\x9f\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g,w={"\b":"\\b","\t":"\\t","\n":"\\n","\f":"\\f","\r":"\\r",
'"':'\\"',"\\":"\\\\"},v=function(a){s.lastIndex=0;return s.test(a)?'"'+a.replace(s,function(a){var c=w[a];return"string"===typeof c?c:"\\u"+("0000"+a.charCodeAt(0).toString(16)).slice(-4)})+'"':'"'+a+'"'},x=function(a,b){if("undefined"!==typeof b[a])return"null /* [...] */";b[a]=!0;switch(typeof a){case "null":a="null";break;case "boolean":a=String(a);break;case "number":a=isFinite(a)?String(a):"null";break;case "string":a=v(a);break;case "function":a=null!==c.annotation(a,"type")?"<"+c.annotation(a,
"type")+">":"<function>";break;case "object":var d=[];if(a)if(null!==c.annotation(a,"type"))a="<"+c.annotation(a,"type")+">";else if("[object Function]"===Object.prototype.toString.call(a))a="<function>";else if("[object Array]"===Object.prototype.toString.call(a)||a instanceof Array){for(var f=0;f<a.length;f++)d[f]=arguments.callee(a[f],b);a=0===d.length?"[]":"["+d.join(",")+"]"}else{for(f in a)if(Object.hasOwnProperty.call(a,f)){var e=arguments.callee(a[f],b);d.push(v(f)+":"+e)}a=0===d.length?"{}":
"{"+d.join(",")+"}"}else a="null";break;default:a="<unknown>"}return a};c.json=function(a){return x(a,{})};c.clone=function(a,b){if("undefined"===typeof b)b=function(){return!0};else if("string"===typeof b){var d=b;b=function(a){return a.match(d)}}var f=arguments.callee,e=function(a,b){var d=function(){return a.apply(this,arguments)};d.prototype=a.prototype;for(var e in a)c.isown(a,e)&&(d[e]=b(e,a)?f(a[e],b):a[e]);c.annotation(d,"clone",!0);return d},h;h=void 0;if("function"===typeof a)h=e(a,b);else if("object"===
typeof a)if(null===a)h=null;else if("[object String]"===Object.prototype.toString.call(a))h=""+a.valueOf();else if("[object Number]"===Object.prototype.toString.call(a))h=0+a.valueOf();else if("[object Boolean]"===Object.prototype.toString.call(a))h=!!a.valueOf();else if("[object Function]"===Object.prototype.toString.call(a))h=e(a,b);else if("[object Date]"===Object.prototype.toString.call(a))h=new Date(a.getTime());else if("[object RegExp]"===Object.prototype.toString.call(a))h=RegExp(a.source);
else if("[object Array]"===Object.prototype.toString.call(a)){e=a.length;h=Array(e);for(var j=0;j<e;j++)h.push(f(a[j],b))}else{h={};for(j in a)"constructor"!==j&&c.isown(a,j)&&(h[j]=b(j,a)?f(a[j],b):a[j]);"function"===typeof a.constructor&&(h.constructor=a.constructor);"object"===typeof a.prototype&&(h.prototype=a.prototype)}else h=a;return h};c.extend=function(a,b,d){if("undefined"===typeof d)d=function(){return!0};else if("string"===typeof d){var f=d;d=function(a){return a.match(f)}}for(var e in b)c.isown(b,
e)&&d(e,b[e])&&(a[e]=b[e]);return a};c.mixin=function(a,b,d){if("undefined"===typeof d)d=function(){return!0};else if("string"===typeof d){var f=d;d=function(a){return a.match(f)}}for(var e in b)if(c.isown(b,e)&&d(e,b[e]))if("function"===c.istypeof(b[e])){var h=c.clone(b[e],d);c.annotation(h,"name",e);"function"===c.istypeof(a[e])&&c.isown(a,e)&&c.annotation(h,"base",a[e]);a[e]=h}else a[e]=b[e];return a};c.concat=function(){for(var a=[],b=0;b<arguments.length;b++)for(var c=arguments[b],f=0;f<c.length;f++)a.push(c[f]);
return a};c.slice=function(a,b,c){var f=[];"undefined"===typeof c&&(c=a.length);for(;b<c;b++)f.push(a[b]);return f};c.map=function(a,b){for(var c=[],f=0;f<a.length;f++)c.push(b(a[f],f));return c};c.filter=function(a,b){for(var c=[],f=0;f<a.length;f++)b(a[f],f)&&c.push(a[f]);return c};c.foreach=function(a,b){for(var c=0;c<a.length;c++)b(a[c],c)};c.token=function(){this.text="";this.tokens=[];this.len=this.pos=0};c.token.prototype={setText:function(a){this.text=a},addToken:function(a,b,c,f,e){this.tokens.push({b1:a,
b2:b,e2:c,e1:f,symbol:e});this.len++},peek:function(a){"undefined"===typeof a&&(a=0);if(a>=this.len)throw Error("parse error: not enough tokens");return this.tokens[this.pos+a].symbol},skip:function(a){"undefined"===typeof a&&(a=1);if(a>this.len)throw Error("parse error: not enough tokens available to skip: "+this.ctx());this.pos+=a;this.len-=a},consume:function(a){if(0>=this.len)throw Error("parse error: no more tokens available to consume: "+this.ctx());if(this.tokens[this.pos].symbol!==a)throw Error('parse error: expected token symbol "'+
a+'": '+this.ctx());this.pos++;this.len--},ctx:function(a){"undefined"===typeof a&&(a=78);var b=this.tokens[this.pos],c="<"+this.text.substr(b.b2,b.e2-b.b2+1)+">",c=this.text.substr(b.b1,b.b2-b.b1)+c,c=c+this.text.substr(b.e2,b.e1-b.e2);a-=c.length;if(0<a){a=Math.floor(a/2);var f;if(0<this.pos){var e=0;for(f=this.pos-1;0<=f;f--){b=this.tokens[f];b=this.text.substr(b.b1,b.e1-b.b1+1);e+=b.length;if(e>a)break;c=b+c}0<f&&(c="[...]"+c)}if(1<this.len){e=0;for(f=this.pos+1;f<this.pos+this.len;f++){b=this.tokens[f];
b=this.text.substr(b.b1,b.e1-b.b1+1);e+=b.length;if(e>a)break;c+=b}f<this.pos+this.len&&(c+="[...]")}}return c=c.replace(/\r/,"\\r").replace(/\n/,"\\n").replace(/\t/,"\\t")}};e.validate=function(a,b,d){var f;d||(f=c.validate_cache[b]);"undefined"===typeof f&&(f=c.validate_compile(b));d||(c.validate_cache[b]=f);return c.validate_executor.exec_spec(a,f)};c.validate_cache={};c.validate_compile=function(a){a=c.validate_tokenize(a);return c.validate_parser.parse_spec(a)};c.validate_tokenize=function(a){var b=
new c.token;b.setText(a);for(var d,f=0;""!==a;){d=a.match(/^(\s*)([^{}\[\]:,?*+()!|\s]+|[{}\[\]:,?*+()!|])(\s*)/);if(null===d)throw Error('parse error: cannot further canonicalize: "'+a+'"');b.addToken(f,f+d[1].length,f+d[1].length+d[2].length-1,f+d[0].length-1,d[2]);a=a.substr(d[0].length);f+=d[0].length}return b};c.validate_parser={parse_spec:function(a){if(0>=a.len)return null;var b=a.peek();if("!"===b)a=this.parse_not(a);else if("("===b)a=this.parse_group(a);else if("{"===b)a=this.parse_hash(a);
else if("["===b)a=this.parse_array(a);else if(b.match(/^(?:undefined|boolean|number|string|function|object)$/))a=this.parse_primary(a);else if(b.match(/^(?:class|trait|component)$/))a=this.parse_special(a);else if("any"===b)a=this.parse_any(a);else if(b.match(/^[A-Z][_a-zA-Z$0-9]*$/))a=this.parse_class(a);else throw Error('parse error: invalid token symbol: "'+a.ctx()+'"');return a},parse_not:function(a){a.consume("!");a=this.parse_spec(a);return a={type:"not",op:a}},parse_group:function(a){a.consume("(");
for(var b=this.parse_spec(a);"|"===a.peek();){a.consume("|");var c=this.parse_spec(a),b={type:"or",op1:b,op2:c}}a.consume(")");return b},parse_hash:function(a){a.consume("{");for(var b=[];"}"!==a.peek();){var c=this.parse_key(a),f=this.parse_arity(a,"?");a.consume(":");var e=this.parse_spec(a);b.push({type:"element",key:c,arity:f,element:e});if(","===a.peek())a.skip();else break}b={type:"hash",elements:b};a.consume("}");return b},parse_array:function(a){a.consume("[");for(var b=[];"]"!==a.peek();){var c=
this.parse_spec(a),f=this.parse_arity(a,"?*+");b.push({type:"element",element:c,arity:f});if(","===a.peek())a.skip();else break}b={type:"array",elements:b};a.consume("]");return b},parse_primary:function(a){var b=a.peek();if(!b.match(/^(?:undefined|boolean|number|string|function|object)$/))throw Error('parse error: invalid primary type "'+b+'"');a.skip();return{type:"primary",name:b}},parse_special:function(a){var b=a.peek();if(!b.match(/^(?:class|trait|component)$/))throw Error('parse error: invalid special type "'+
b+'"');a.skip();return{type:"special",name:b}},parse_any:function(a){var b=a.peek();if("any"!==b)throw Error('parse error: invalid any type "'+b+'"');a.skip();return{type:"any"}},parse_class:function(a){var b=a.peek();if(!b.match(/^[A-Z][_a-zA-Z$0-9]*$/))throw Error('parse error: invalid class type "'+b+'"');a.skip();return{type:"class",name:b}},parse_arity:function(a,b){var c=[1,1];if(5<=a.len&&"{"===a.peek(0)&&a.peek(1).match(/^[0-9]+$/)&&","===a.peek(2)&&a.peek(3).match(/^(?:[0-9]+|oo)$/)&&"}"===
a.peek(4))c=[parseInt(a.peek(1),10),"oo"===a.peek(3)?Number.MAX_VALUE:parseInt(a.peek(3),10)],a.skip(5);else if(1<=a.len&&1===a.peek().length&&0<=b.indexOf(a.peek())){switch(a.peek()){case "?":c=[0,1];break;case "*":c=[0,Number.MAX_VALUE];break;case "+":c=[1,Number.MAX_VALUE]}a.skip()}return c},parse_key:function(a){var b=a.peek();if(!b.match(/^[_a-zA-Z$][_a-zA-Z$0-9]*$/))throw Error('parse error: invalid key "'+b+'"');a.skip();return b}};c.validate_executor={exec_spec:function(a,b){var c=!1;if(null!==
b)switch(b.type){case "not":c=this.exec_not(a,b);break;case "or":c=this.exec_or(a,b);break;case "hash":c=this.exec_hash(a,b);break;case "array":c=this.exec_array(a,b);break;case "primary":c=this.exec_primary(a,b);break;case "special":c=this.exec_special(a,b);break;case "class":c=this.exec_class(a,b);break;case "any":c=!0;break;default:throw Error('validation error: invalid validation tree: node has unknown type "'+b.type+'"');}return c},exec_not:function(a,b){return!this.exec_spec(a,b.op)},exec_or:function(a,
b){return this.exec_spec(a,b.op1)||this.exec_spec(a,b.op2)},exec_hash:function(a,b){var c,f,e="object"===typeof a,h={};if(e)for(c=0;c<b.elements.length;c++)if(f=b.elements[c],h[f.key]=f.element,0<f.arity[0]&&"undefined"===typeof a[f.key]){e=!1;break}if(e)for(var j in a)if(Object.hasOwnProperty.call(a,j)&&("undefined"===typeof h[j]||!this.exec_spec(a[j],h[j]))){e=!1;break}return e},exec_array:function(a,b){var c,f,e="object"===typeof a&&a instanceof Array;if(e){var h=0;for(c=0;c<b.elements.length;c++){f=
b.elements[c];for(var j=0;j<f.arity[1]&&h<a.length&&this.exec_spec(a[h],f.element);)j++,h++;if(j<f.arity[0]){e=!1;break}}h<a.length&&(e=!1)}return e},exec_primary:function(a,b){return typeof a===b.name},exec_class:function(a,b){return"object"===typeof a&&Object.prototype.toString.call(a)==="[object "+b.name+"]"||eval("value instanceof "+b.name)},exec_special:function(a,b){var d=!1;if(typeof a===("component"===b.name?"object":"function"))d=c.annotation(a,"type")===b.name;return d}};e.params=function(a,
b,d){c.hook("ComponentJS:params:"+a,"none",{args:b,spec:d});var f={},g=0,h=0,j={},k;for(k in d)c.isown(d,k)&&("undefined"!==typeof d[k].pos&&(j[d[k].pos]=k,"number"===typeof d[k].pos&&g++,"undefined"!==typeof d[k].req&&d[k].req&&h++),"undefined"!==typeof d[k].def&&(f[k]=d[k].def));var l=!1;if(1===b.length&&"object"===c.istypeof(b[0]))for(k in l=!0,b[0])c.isown(b[0],k)&&"undefined"===typeof d[k]&&(l=!1);var t=function(a,b,d,f){if("string"===typeof f){if(!e.validate(d,f))throw c.exception(a,'value of parameter "'+
b+'" not valid');}else if("object"===typeof f&&f instanceof RegExp){if(!("string"===typeof d&&d.match(f)))throw c.exception(a,'value of parameter "'+b+'" not valid (regexp)');}else if("function"===typeof f&&!f(d))throw c.exception(a,'value of parameter "'+b+'" not valid (callback)');};if(l){g=b[0];for(k in g)if(c.isown(g,k)){if("undefined"===typeof d[k])throw c.exception(a,'unknown parameter "'+k+'"');t(a,k,g[k],d[k].valid);f[k]=g[k]}for(k in d)if(c.isown(d,k)&&"undefined"!==typeof d[k].req&&d[k].req&&
"undefined"===g[k])throw c.exception(a,'required parameter "'+k+'" missing');}else{if(b.length<h)throw c.exception(a,"invalid number of arguments (at least "+h+" required)");for(k=0;k<g&&k<b.length;k++)t(a,j[k],b[k],d[j[k]].valid),f[j[k]]=b[k];if(k<b.length){if("undefined"===typeof j["..."])throw c.exception(a,"too many arguments provided");for(g=[];k<b.length;k++)t(a,j["..."],b[k],d[j["..."]].valid),g.push(b[k]);f[j["..."]]=g}}return f};c.base16_number=function(a,b,c){var f="";"undefined"===typeof b&&
(b=0);"undefined"===typeof c&&(c=!1);for(c=c?"0123456789ABCDEF":"0123456789abcdef";0<a||0<b;)f=c.charAt(Math.floor(a%16))+f,a=Math.floor(a/16),0<b&&b--;return f};var m=[0,0,0,0];c.cid=function(){m[3]++;for(var a=0,b=3;0<=b;b--)a+=m[b],m[b]=Math.floor(a%4294967296),a=Math.floor(a/4294967296);return c.base16_number(m[0],8,!0)+c.base16_number(m[1],8,!0)+c.base16_number(m[2],8,!0)+c.base16_number(m[3],8,!0)};c.proxy=function(a,b,d){"string"===c.istypeof(b)&&"object"===c.istypeof(a)&&"function"===c.istypeof(a[b])&&
(b=a[b]);c.isdefined(d)||(d=!1);var f=function(){var e=function(){"object"===c.istypeof(arguments.callee.__ctx__)&&(arguments.callee.__ctx__.__this__=this);return b.apply(arguments.callee.__ctx__,arguments)};e.__ctx__=d?c.clone(c.isdefined(this.__ctx__)?this.__ctx__:a):a;d&&(e.clone=f);e.guid=b.guid=b.guid||e.guid||c.cid();return e};return f.call({})};c.memoize=function(a){var b=function(){var b=c.json(c.slice(arguments,0)),f;"undefined"!==typeof arguments.callee.cache[b]?f=arguments.callee.cache[b]:
(f=a.apply(this,arguments),arguments.callee.cache[b]=f);return f};b.cache={};return b};c.curry=function(a){var b=c.slice(arguments,1);return function(){var d=c.slice(arguments,0),d=c.concat(b,d);return a.apply(this,d)}};e.attribute=function(){var a=e.params("attribute",arguments,{name:{pos:0,def:null,req:!0},def:{pos:1,def:null,req:!0},validate:{pos:2,def:null}});return c.proxy({value:a.def},function(b,d){var f=this.value;if(0<arguments.length){var e=!0;if(null!==a.validate)if("string"===typeof a.validate||
"boolean"===typeof a.validate||"number"===typeof a.validate)e=b===a.validate;else if("object"===typeof a.validate&&a.validate instanceof RegExp)e=a.validate.test(b);else if("function"===typeof a.validate)e=a.validate(b,f,d,a.name);else throw c.exception("attribute",'validation value "'+a.validate+'" for attribute "'+a.name+'" is of unsupported type "'+typeof a.validate+'"');if("undefined"!==typeof d&&d)return e;if(e)this.value=b,e=this.__this__,"undefined"!==typeof e&&"function"===typeof e.notify&&
e.notify.call(e,"attribute:set:"+a.name,b,f,a.name);else throw c.exception("attribute",'invalid value "'+b+'" for attribute "'+a.name+'"');}return f},!0)};c.hooks={};c.hook_proc={none:{init:void 0,step:function(){}},pass:{init:function(a){return a[0]},step:function(a,b){return b}},or:{init:!1,step:function(a,b){return a||b}},and:{init:!0,step:function(a,b){return a&&b}},mult:{init:1,step:function(a,b){return a*b}},add:{init:0,step:function(a,b){return a+b}},append:{init:"",step:function(a,b){return a+
b}},push:{init:[],step:function(a,b){a.push(b);return a}},concat:{init:[],step:function(a,b){return c.concat(a,b)}},insert:{init:{},step:function(a,b){a[b]=!0;return a}},extend:{init:{},step:function(a,b){return c.extend(a,b)}}};c.latch=function(a,b){if(2>arguments.length)throw c.exception("latch(internal)","missing arguments");"undefined"===typeof c.hooks[a]&&(c.hooks[a]=[]);var d=c.slice(arguments,2),f=c.cid();c.hooks[a].push({id:f,cb:b,args:d});return f};c.unlatch=function(a,b){if(2!==arguments.length)throw c.exception("unlatch(internal)",
"invalid number of arguments");if("undefined"===typeof c.hooks[a])throw c.exception("unlatch(internal)","no such hook");for(var d=-1,f=0;f<c.hooks[a].length;f++)if(c.hooks[a][f].id===b){d=f;break}if(-1===d)throw c.exception("unlatch(internal)","no such latched callback");c.hooks[a]=c.hooks[a].splice(d,1)};c.hook=function(a,b){if(2>arguments.length)throw c.exception("hook(internal)","missing argument");if("undefined"===typeof c.hook_proc[b])throw c.exception("hook(internal)","no such result processing defined");
var d=c.hook_proc[b].init,f=null;"function"===typeof d&&(f=c.slice(arguments,2),d=d.call(null,f));"undefined"!==typeof c.hooks[a]&&(null===f&&(f=c.slice(arguments,2)),c.foreach(c.hooks[a],function(a){a=a.cb.apply({args:a.args,_cs:c,$cs:e},f);d=c.hook_proc[b].step.call(null,d,a)}));return d};c.clazz_or_trait=function(a,b){var d=function(){var a=arguments.callee,b=arguments;if(!(this instanceof a))return new a;(function(a,b,d,f){null!==c.annotation(b,"extend")&&arguments.callee(a,c.annotation(b,"extend"),
d,!1);if(null!==c.annotation(b,"mixin"))for(var e=c.annotation(b,"mixin"),g=0;g<e.length;g++)arguments.callee(a,e[g],d,!0);if(null!==c.annotation(b,"dynamics")){var e=c.annotation(b,"dynamics"),j;for(j in e)c.isown(e,j)&&(a[j]="null"!==c.istypeof(e[j])&&"function"===c.istypeof(e[j].clone)?e[j].clone():c.clone(e[j]))}f&&null!==c.annotation(b,"cons")&&(j=c.annotation(b,"cons"),"clazz"===c.istypeof(b)?j.apply(a,d):j.call(a))})(this,a,b,!0)},f=function(a){return!a.match("^(?:base|__ComponentJS_[A-Za-z]+__)$")};
if(c.isdefined(a.extend)){c.extend(d,a.extend,f);var g=function(){this.constructor=d};g.prototype=a.extend.prototype;d.prototype=new g;c.annotation(d,"extend",a.extend)}if(c.isdefined(a.mixin)){for(g=0;g<a.mixin.length;g++)c.extend(d,a.mixin[g],f),c.mixin(d.prototype,a.mixin[g].prototype,f);c.annotation(d,"mixin",a.mixin)}c.isdefined(a.cons)?c.annotation(d,"cons",a.cons):c.isdefined(a.extend)?c.annotation(d,"cons",function(){this.base()}):c.annotation(d,"cons",e.nop);c.annotation(c.annotation(d,"cons"),
"name","cons");c.isdefined(a.extend)&&c.annotation(c.annotation(d,"cons"),"base",c.annotation(a.extend,"cons"));c.isdefined(a.setup)&&c.annotation(d,"setup",a.setup);c.isdefined(a.statics)&&c.extend(d,a.statics);c.isdefined(a.protos)&&c.mixin(d.prototype,a.protos);c.isdefined(a.dynamics)&&c.annotation(d,"dynamics",a.dynamics);var h=function(a,b){for(var d=c.annotation(a,b);null===d&&!0===c.annotation(a.caller,"clone");)d=c.annotation(a.caller,b),a=a.caller;return d};d.prototype.base=function(){var a=
h(arguments.callee.caller,"name"),b=h(arguments.callee.caller,"base"),d=c.annotation(this.constructor,"extend");if("function"===c.istypeof(b))return b.apply(this,arguments);if("string"===c.istypeof(a)&&"clazz"===c.istypeof(d)&&"function"===c.istypeof(d[a]))return d[a].apply(this,arguments);if("string"===c.istypeof(a)&&"clazz"===c.istypeof(d)&&"object"===c.istypeof(d.prototype)&&"function"===c.istypeof(d.prototype[a]))return d.prototype[a].apply(this,arguments);throw c.exception("base",'no base method found for method "'+
a+'" in inheritance/mixin chain');};b&&function(a,b){if("array"===c.istypeof(c.annotation(b,"mixin")))for(var d=c.annotation(b,"mixin"),f=0;f<d.length;f++)arguments.callee(a,d[f]);"function"===c.istypeof(c.annotation(b,"setup"))&&c.annotation(b,"setup").call(a)}(d,d);"string"===typeof a.name&&e.ns(a.name,d);return d};e.clazz=function(){var a=e.params("clazz",arguments,{name:{def:void 0,valid:"string"},extend:{def:void 0,valid:"clazz"},mixin:{def:void 0,valid:"[trait*]"},cons:{def:void 0,valid:"function"},
dynamics:{def:void 0,valid:"object"},protos:{def:void 0,valid:"object"},statics:{def:void 0,valid:"object"}}),a=c.clazz_or_trait(a,!0);c.annotation(a,"type","clazz");return a};e.trait=function(){var a=e.params("trait",arguments,{name:{def:void 0,valid:"string"},mixin:{def:void 0,valid:"[trait*]"},cons:{def:void 0,valid:"function"},setup:{def:void 0,valid:"function"},dynamics:{def:void 0,valid:"object"},protos:{def:void 0,valid:"object"},statics:{def:void 0,valid:"object"}}),a=c.clazz_or_trait(a,!1);
c.annotation(a,"type","trait");return a};e.pattern.id=e.trait({dynamics:{id:e.attribute("id",null)}});e.pattern.name=e.trait({dynamics:{name:e.attribute("name","")}});e.pattern.tree=e.trait({mixin:[e.pattern.name],dynamics:{parent:e.attribute("parent",null),children:e.attribute("children",[])},protos:{path:function(a){var b,c;if("undefined"===typeof a){b=[];for(c=this;null!==c;c=c.parent())b.push(c)}else if(b="",null===this.parent())b=a;else for(c=this;null!==c.parent();c=c.parent())b=a+c.name()+
b;return b},_attach:function(a){null!==this.parent()&&this.detach();var b=a.children();b.push(this);a.children(b);this.parent(a)},_detach:function(){if(null!==this.parent()){var a=this;this.parent().children(c.filter(this.parent().children(),function(b){return b!==a}));this.parent(null)}},walk_up:function(a,b){var c,f;c=0;for(f=this;null!==f;f=f.parent(),c++)b=a(c,f,b);return b},walk_down:function(a,b){var c=function(b,e,h){"function"===typeof a&&(h=a(b,e,h,!1));for(var j=e.children(),k=0;k<j.length;k++)h=
c(b+1,j[k],h);"function"===typeof a&&(h=a(b,e,h,!0));return h};return b=c(0,this,b)},_tree_dump:function(a){return this.walk_down(function(b,c,f,e){if(!e){for(e=0;e<b;e++)f+="    ";f+='"'+c.name()+'"';"function"===typeof a&&(f+=": "+a(c));f+="\n"}return f},"")}}});e.pattern.config=e.trait({dynamics:{__config:{}},protos:{cfg:function(a,b){var d;if(0===arguments.length){d=[];for(var f in this.__config)c.isown(this.__config,f)&&d.push(f)}else if(1===arguments.length&&"string"===typeof a)d=this.__config[a];
else if(2===arguments.length&&"undefined"!==typeof b)d=this.__config[a],this.__config[a]=b;else if(2===arguments.length)d=this.__config[a],delete this.__config[a];else throw c.exception("cfg","invalid arguments");return d}}});e.pattern.spool=e.trait({dynamics:{__spool:{}},protos:{spool:function(){var a=e.params("spool",arguments,{name:{pos:0,req:!0},ctx:{pos:1,def:this},func:{pos:2,def:e.nop,req:!0},args:{pos:"...",def:[]}});if(!c.istypeof(a.func).match(/^(string|function)$/))throw c.exception("cleaner",
"invalid function (either function object or method name required)");if("string"===c.istypeof(a.func)){if("function"!==c.istypeof(a.ctx[a.func]))throw c.exception("cleaner",'invalid method name: "'+a.func+'"');a.func=a.ctx[a.func]}c.isdefined(this.__spool[a.name])||(this.__spool[a.name]=[]);this.__spool[a.name].push(a)},spooled:function(){var a=e.params("spooled",arguments,{name:{pos:0,req:!0}});return c.isdefined(this.__spool[a.name])&&0<this.__spool[a.name].length},unspool:function(){var a=e.params("unspool",
arguments,{name:{pos:0,req:!0}}),b=this.__spool[a.name];if(!c.isdefined(b))throw c.exception("unspool",'no such spool: "'+a.name+'"');for(var d=b.length-1;0<=d;d--)b[d].func.apply(b[d].ctx,b[d].args);delete this.__spool[a.name]}}});e.pattern.property=e.trait({mixin:[e.pattern.tree,e.pattern.config],protos:{property:function(){var a=e.params("property",arguments,{name:{pos:0,def:null,req:!0},value:{pos:1,def:void 0},bubbling:{def:!0},targeting:{def:!0},returnowner:{def:!1}});if(!a.targeting&&!a.bubbling)throw c.exception("property",
"disabling both targeting and bubbling makes no sense");var b;b=void 0;var d;d=null;for(var f=this;null!==f;d=f.name(),f=f.parent())if(null!==d||a.targeting){if(null!==d&&(d=f.cfg("ComponentJS:property:"+a.name+"@"+d),"undefined"!==typeof d)){b=a.returnowner?f:d;break}d=f.cfg("ComponentJS:property:"+a.name);if("undefined"!==typeof d){b=a.returnowner?f:d;break}if(!a.bubbling)break}"undefined"!==typeof a.value&&this.cfg("ComponentJS:property:"+a.name,a.value);return b}}});e.pattern.spec=e.trait({mixin:[e.pattern.name],
dynamics:{__spec:{}},protos:{spec:function(){var a=this.__spec;if(0===arguments.length)return a;if(1===arguments.length&&"string"===typeof arguments[0])return a[arguments[0]];for(var b=0;b<arguments.length;b++)if("string"===typeof arguments[b])a[arguments[b]]=arguments[b+1],b++;else if("object"===typeof arguments[b])for(var d in arguments[b])c.isown(arguments[b],d)&&(a[d]=arguments[b][d])},matches:function(a,b){if("string"===typeof a){if(this.name()!==a)return!1}else if("object"===typeof a&&a instanceof
RegExp){if(!this.name().match(a))return!1}else throw c.exception("matches","invalid name pattern");var d=this.__spec,f;for(f in b)if(c.isown(b,f)){if(!c.isdefined(d[f]))return!1;var e=b[f];switch(typeof d[f]){case "number":case "boolean":if(d[f]!==e)return!1;break;case "string":if(!("string"===typeof e&&d[f]===e||"object"===typeof e&&e instanceof RegExp&&!d[f].match(e)))return!1}}return!0}}});e.pattern.observable=e.trait({dynamics:{__listener:{}},protos:{listen:function(){var a=e.params("listen",
arguments,{name:{pos:0,def:null,req:!0},ctx:{pos:1,def:this},func:{pos:2,def:e.nop,req:!0},args:{pos:"...",def:[]},spec:{def:null}}),b=c.cid();this.__listener[b]=a;return b},listening:function(){var a=e.params("listening",arguments,{id:{pos:0,def:null,req:!0}});return"undefined"!==typeof this.__listener[a.id]},unlisten:function(){var a=e.params("unlisten",arguments,{id:{pos:0,def:null,req:!0}});if("undefined"===typeof this.__listener[a.id])throw c.exception("unlisten","listener not found");var b=
this.__listener[a.id];delete this.__listener[a.id];return b},notify:function(){var a=e.params("notify",arguments,{name:{pos:0,def:null,req:!0},args:{pos:"...",def:[]},matches:{def:function(a,b){return a.name===b.name}}}),b;for(b in this.__listener)if(c.isown(this.__listener,b)){var d=this.__listener[b];if(a.matches(a,d)){var f=c.concat(d.args,a.args);d.func.apply(d.ctx,f)}}}}});e.pattern.event=e.clazz({mixin:[e.pattern.spec],dynamics:{target:e.attribute("target",null),propagation:e.attribute("propagation",
!0),processing:e.attribute("processing",!0),dispatched:e.attribute("dispatched",!1),decline:e.attribute("decline",!1),state:e.attribute("state","targeting"),result:e.attribute("result",void 0),async:e.attribute("async",!1)}});e.event=function(){var a=e.params("event",arguments,{name:{pos:0,def:null,req:!0},spec:{def:{}},target:{pos:1,def:null,req:!0},propagation:{pos:2,def:!0},processing:{pos:3,def:!0},dispatched:{pos:4,def:!1},decline:{pos:5,def:!1},state:{pos:6,def:"targeting"},result:{pos:7,def:void 0},
async:{pos:8,def:!1}}),b=new e.pattern.event;b.name(a.name);b.target(a.target);b.propagation(a.propagation);b.processing(a.processing);b.dispatched(a.dispatched);b.decline(a.decline);b.state(a.state);b.result(a.result);b.spec(a.spec);b.async(a.async);return b};e.pattern.eventing=e.trait({dynamics:{__subscription:{}},protos:{subscribe:function(){var a=e.params("subscribe",arguments,{name:{pos:0,def:null,req:!0},spec:{def:{}},ctx:{def:this},func:{pos:1,def:e.nop,req:!0},args:{pos:"...",def:[]},capturing:{def:!1},
spreading:{def:!1},bubbling:{def:!0},noevent:{def:!1},exclusive:{def:!1},spool:{def:null}}),b=this._subscriptions(a.name,a.spec);if(1===b.length&&b[0].exclusive)throw c.exception("subscribe","existing exclusive subscription prevents additional one");if(a.exclusive&&0<b.length)throw c.exception("subscribe","non-exclusive subscription(s) prevent exclusive one");b=c.cid();this.__subscription[b]=a;null!==a.spool&&this.spool(a.spool,this,"unsubscribe",b);return b},unsubscribe:function(){var a=e.params("unsubscribe",
arguments,{id:{pos:0,req:!0}});if("undefined"===typeof this.__subscription[a.id])throw c.exception("unsubscribe","subscription not found");delete this.__subscription[a.id]},subscription:function(){var a=e.params("subscription",arguments,{id:{pos:0,req:!0}});return"undefined"!==typeof this.__subscription[a.id]},_subscriptions:function(){var a=e.params("subscriptions",arguments,{name:{pos:0,def:null,req:!0},spec:{pos:1,def:{}}}),a=e.event({name:a.name,spec:a.spec}),b=[],d;for(d in this.__subscription)if(c.isown(this.__subscription,
d)){var f=this.__subscription[d];a.matches(f.name,f.spec)&&b.push(f)}return b},publish:function(){var a,b=this,d=e.params("publish",arguments,{name:{pos:0,def:null,req:!0},spec:{def:{}},async:{def:!1},capturing:{def:!0},spreading:{def:!0},bubbling:{def:!0},completed:{def:e.nop},resultinit:{def:void 0},resultstep:{def:function(a,b){return b}},directresult:{def:!1},noresult:{def:!1},firstonly:{def:!1},silent:{def:!1},args:{pos:"...",def:[]}}),f=!1;if(!d.capturing&&!d.spreading&&!d.bubbling){var g=!1,
h;for(h in this.__subscription)if(c.isown(this.__subscription,h)){g=!0;break}if(!g){if(d.noresult)return;if(d.directresult)return d.resultinit;f=!0}}var j=e.event({name:d.name,spec:d.spec,async:d.async,result:d.resultinit,target:b,propagation:!0,processing:!0,dispatched:!1});if(f)return j;d.silent||e.debug(1,"event: "+j.target().path("/")+": publish: name="+j.name()+" async="+j.async()+" capturing="+d.capturing+" spreading="+d.spreading+" bubbling="+d.bubbling+" directresult="+d.directresult+" noresult="+
d.noresult+" firstonly="+d.firstonly);var k=function(a,b,d,f){for(var g in b.__subscription)if(c.isown(b.__subscription,g)){var h=b.__subscription[g];if(("capturing"===f&&h.capturing||"targeting"===f||"spreading"===f&&h.spreading||"bubbling"===f&&h.bubbling)&&a.matches(h.name,h.spec)){d.silent||e.debug(1,"event: "+b.path("/")+": dispatch on "+f);a.state(f);a.decline(!1);var j=c.concat(h.noevent?[]:[a],h.args,d.args),j=h.func.apply(h.ctx,j);h.noevent&&c.isdefined(j)&&a.result(d.resultstep(a.result(),
j));a.decline()||(a.dispatched(!0),d.firstonly&&a.propagation(!1))}}},l=function(b,c,d){var f;if(d.capturing||d.bubbling)f=c.path();if(d.capturing)for(a=f.length-1;1<=a&&!(k(b,f[a],d,"capturing"),!b.propagation());a--);b.propagation()&&k(b,c,d,"targeting");if(d.spreading&&b.propagation()){var e=function(a,c){var f=!0;c||(k(b,a,d,"spreading"),b.propagation()||(b.propagation(!0),f=!1));if(f)for(var f=a.children(),g=0;g<f.length;g++)e(f[g],!1)};e(c,!0)}if(d.bubbling&&b.propagation())for(a=1;a<f.length&&
!(k(b,f[a],d,"bubbling"),!b.propagation());a++);d.completed.call(c,b)};j.async()?setTimeout(function(){l(j,b,d)},0):l(j,b,d);if(!d.noresult)return d.directresult?j.result():j}}});e.pattern.command=e.clazz({mixin:[e.pattern.observable],dynamics:{ctx:e.attribute("ctx",null),func:e.attribute("func",e.nop),args:e.attribute("args",[]),async:e.attribute("async",!1),enabled:e.attribute({name:"enabled",def:!0,validate:function(a){return"boolean"===typeof a}})},protos:{execute:function(a,b){if(this.enabled()){var d=
[];this.async()&&d.push(function(a){"function"===typeof b&&b(a)});d=c.concat(d,this.args(),a);return this.func().apply(this.ctx(),d)}}}});e.command=function(){var a=e.params("command",arguments,{ctx:{def:null},func:{pos:0,def:null,req:!0},args:{pos:"...",def:[]},async:{def:!1},enabled:{def:!0},wrap:{def:!1}}),b=new e.pattern.command;b.ctx(a.ctx);b.func(a.func);b.args(a.args);b.async(a.async);b.enabled(a.enabled);var d=b;a.wrap&&(d=function(){var a=c.concat(arguments);return arguments.callee.command.execute.call(arguments.callee.command,
a)},d.command=b);return d};c.states=[{enter:null,leave:null,state:"dead",color:"#000000"}];c.states_clear=function(){c.states=c.slice(c.states,0,1)};c.states_add=function(a,b,d,f,e){a={enter:b,leave:d,state:a,color:f};for(b=1;b<c.states.length&&!(null!==e&&c.states[b].state===e);)b++;c.states.splice(b,0,a)};c.state_name2idx=function(a){var b=-1,d;for(d=0;d<c.states.length;d++)if(c.states[d].state===a){b=d;break}return b};c.state_method_call=function(a,b,d){var f=!0,e=b.obj();null!==e&&"function"===
typeof e[d]&&(a={type:a,comp:b,method:d,ctx:e,func:e[d]},c.hook("ComponentJS:state-method-call","none",a),f=a.func.call(a.ctx));return f};c.state_requests={};c.state_progression=function(){setTimeout(function(){var a=[],b;for(b in c.state_requests)c.isown(c.state_requests,b)&&c.state_progression_single(c.state_requests[b])&&a.push(b);c.foreach(a,function(a){delete c.state_requests[a]});c.hook("ComponentJS:state-change","none")},0)};c.state_progression_single=function(a){var b=!1;c.state_progression_run(a.comp,
a.state);a.comp.state()===a.state&&("function"===typeof a.callback&&a.callback.call(a.comp,a.state),b=!0);return b};c.state_progression_run=function(a,b,d){var f,g;"undefined"===typeof d&&(d="upward-and-downward");var h=c.state_name2idx(b);if(-1===h)throw c.exception("state",'invalid argument "'+b+'"');if(a.__state<h)for(;a.__state<h;){g=c.states[a.__state+1].state;f=c.states[a.__state+1].enter;if(null!==a.parent()&&0>a.parent().state_compare(g)&&(c.state_progression_run(a.parent(),g,"upward"),0>
a.parent().state_compare(g))){e.debug(1,"state: "+a.path("/")+": transition (increase) REJECTED BY PARENT COMPONENT ("+a.parent().path("/")+"): @"+c.states[a.__state].state+" --("+f+")--\x3e @"+c.states[a.__state+1].state+": SUSPENDING CURRENT TRANSITION RUN");break}if(c.isdefined(a.__state_guards[f])){e.debug(1,"state: "+a.path("/")+": transition (increase) REJECTED BY ENTER GUARD: @"+c.states[a.__state].state+" --("+f+")--\x3e @"+c.states[a.__state+1].state+": SUSPENDING CURRENT TRANSITION RUN");
break}a.__state++;e.debug(1,"state: "+a.path("/")+": transition (increase): @"+c.states[a.__state-1].state+" --("+f+")--\x3e @"+c.states[a.__state].state);c.hook("ComponentJS:state-invalidate","none","states");c.hook("ComponentJS:state-change","none");b="ComponentJS:state:"+c.states[a.__state].state+":enter";a.spooled(b)&&a.unspool(b);if(!1===c.state_method_call("enter",a,f)){e.debug(1,"state: "+a.path("/")+": transition (increase) REJECTED BY ENTER METHOD: @"+c.states[a.__state-1].state+" --("+f+
")--\x3e @"+c.states[a.__state].state+": SUSPENDING CURRENT TRANSITION RUN");a.__state--;break}a.publish({name:"ComponentJS:state:"+c.states[a.__state].state,noresult:!0,capturing:!1,spreading:!1,bubbling:!1,async:!0,silent:!0});if("upward-and-downward"===d||"downward"===d){f=a.children();for(b=0;b<f.length;b++)if(0>f[b].state_compare(g)&&(f[b].state_auto_increase()||!0===f[b].property("ComponentJS:state-auto-increase")))c.state_progression_run(f[b],g,"downward"),0>f[b].state_compare(g)&&(c.state_requests[f[b].id()]=
{comp:f[b],state:g},c.hook("ComponentJS:state-invalidate","none","requests"),c.hook("ComponentJS:state-change","none"))}}else if(a.__state>h)for(;a.__state>h;){g=c.states[a.__state].leave;var j=c.states[a.__state-1].state;f=a.children();for(b=0;b<f.length;b++)if(0<f[b].state_compare(j)&&(c.state_progression_run(f[b],j,"downward"),0<f[b].state_compare(j))){e.debug(1,"state: "+a.path("/")+": transition (decrease) REJECTED BY CHILD COMPONENT ("+f[b].path("/")+"): @"+c.states[a.__state-1].state+" <--("+
g+")-- @"+c.states[a.__state].state+": SUSPENDING CURRENT TRANSITION RUN");return}if(c.isdefined(a.__state_guards[g])){e.debug(1,"state: "+a.path("/")+": transition (decrease) REJECTED BY LEAVE GUARD: @"+c.states[a.__state-1].state+" <--("+g+")-- @"+c.states[a.__state].state+": SUSPENDING CURRENT TRANSITION RUN");break}a.__state--;e.debug(1,"state: "+a.path("/")+": transition (decrease): @"+c.states[a.__state].state+" <--("+g+")-- @"+c.states[a.__state+1].state);c.hook("ComponentJS:state-invalidate",
"none","states");c.hook("ComponentJS:state-change","none");b="ComponentJS:state:"+c.states[a.__state+1].state+":leave";a.spooled(b)&&a.unspool(b);if(!1===c.state_method_call("leave",a,g)){e.debug(1,"state: "+a.path("/")+": transition (decrease) REJECTED BY LEAVE METHOD: @"+c.states[a.__state].state+" <--("+g+")-- @"+c.states[a.__state+1].state+": SUSPENDING CURRENT TRANSITION RUN");a.__state++;break}a.publish({name:"ComponentJS:state:"+c.states[a.__state].state,noresult:!0,capturing:!1,spreading:!1,
bubbling:!1,async:!0,silent:!0});if("upward-and-downward"===d||"upward"===d)if(null!==a.parent()&&0<a.parent().state_compare(j)&&(a.parent().state_auto_decrease()||!0===a.parent().property("ComponentJS:state-auto-decrease")))c.state_progression_run(a.parent(),j,"upward"),0<a.parent().state_compare(j)&&(c.state_requests[a.parent().id()]={comp:a.parent(),state:j},c.hook("ComponentJS:state-invalidate","none","requests"),c.hook("ComponentJS:state-change","none"))}};e.pattern.state=e.trait({mixin:[e.pattern.tree],
dynamics:{__state:0,__state_guards:{},state_auto_increase:e.attribute("state_auto_increase",!1),state_auto_decrease:e.attribute("state_auto_decrease",!1)},protos:{state:function(){var a=c.states[this.__state].state;if(0===arguments.length)return a;var b=e.params("state",arguments,{state:{pos:0,req:!0,valid:function(a){return-1!==c.state_name2idx(a)}},callback:{pos:1,def:void 0},sync:{def:!1}});if(c.states[this.__state].state!==b.state){var d=!0,f={comp:this,state:b.state,callback:b.callback};b.sync&&
c.state_progression_single(f)&&(d=!1);d&&(c.state_requests[this.id()]=f,c.hook("ComponentJS:state-invalidate","none","requests"),c.state_progression())}else"function"===typeof b.callback&&b.callback.call(this,b.state);return a},state_compare:function(){var a=e.params("state",arguments,{state:{pos:0,req:!0,valid:function(a){return-1!==c.state_name2idx(a)}}}),a=c.state_name2idx(a.state);return this.__state-a},guard:function(){var a=e.params("guard",arguments,{method:{pos:0,valid:"string",req:!0},level:{pos:1,
valid:"number",req:!0}}),b=!1,d;for(d=0;d<c.states.length;d++)if(c.states[d].enter===a.method||c.states[d].leave===a.method){b=!0;break}if(!b)throw c.exception("guard",'no such declared enter/leave method: "'+a.method+'"');c.isdefined(this.__state_guards[a.method])||(this.__state_guards[a.method]=0);b=!1;if(0<a.level)this.__state_guards[a.method]+=a.level;else if(0>a.level){if(this.__state_guards[a.method]<-a.level)throw c.exception("guard","guard level decrease request too large");this.__state_guards[a.method]+=
a.level;0===this.__state_guards[a.method]&&(b=!0)}else this.__state_guards[a.method]=0,b=!0;b&&(delete this.__state_guards[a.method],c.state_progression())}}});e.pattern.service=e.trait({mixin:[e.pattern.eventing],protos:{register:function(){var a=e.params("register",arguments,{name:{pos:0,def:null,req:!0},ctx:{def:this},func:{pos:1,def:e.nop,req:!0},args:{pos:"...",def:[]},async:{def:!1},spool:{def:null},capturing:{def:!1},spreading:{def:!1},bubbling:{def:!0}}),b=e.command({ctx:a.ctx,func:a.func,
args:a.args,async:a.async,wrap:!0});b.command.listen({name:"attribute:set:enabled",args:[this,a.name],func:function(a,b,c,e){a.publish({name:"ComponentJS:service:"+b+":callable",args:[c,e],capturing:!1,spreading:!1,bubbling:!1,async:!0,noresult:!0})}});b=this.subscribe({name:"ComponentJS:service:"+a.name,ctx:a.ctx,func:b,noevent:!0,capturing:a.capturing,spreading:a.spreading,bubbling:a.bubbling,exclusive:!0});null!==a.spool&&this.spool(a.spool,this,"unregister",b);return b},registration:function(){var a=
e.params("registration",arguments,{id:{pos:0,req:!0}});return this.subscription(a.id)},unregister:function(){var a=e.params("unregister",arguments,{id:{pos:0,req:!0}});this.unsubscribe(a.id)},callable:function(){var a=e.params("callable",arguments,{name:{pos:0,def:null,req:!0},value:{pos:1,def:void 0}}),b=this._subscriptions(a.name);return 1!==b.length?void 0:b[0].func().command.enabled(a.value)},call:function(){var a=e.params("call",arguments,{name:{pos:0,def:null,req:!0},args:{pos:"...",def:[]},
capturing:{def:!1},spreading:{def:!1},bubbling:{def:!0}}),b=this.publish({name:"ComponentJS:service:"+a.name,args:a.args,capturing:a.capturing,spreading:a.spreading,bubbling:a.bubbling,firstonly:!0,async:!1});if(!b.dispatched())throw c.exception("call",'no such registered service found: "'+a.name+'"');return b.result()}}});e.pattern.shadow=e.trait({dynamics:{__obj:null},protos:{obj:function(a){if("undefined"===typeof a)return this.__obj;if("object"===typeof a)null!==a?(c.annotation(a,"comp",this),
this.__obj=a):(null!==this.__obj&&c.annotation(this.__obj,"comp",null),this.__obj=null);else throw c.exception("obj","invalid argument");return this},access:function(a,b){if("undefined"===typeof a)throw c.exception("access","no attribute name given");var d=this.obj();if(null===d)throw c.exception("access","still no object attached");if("undefined"===typeof d[a])throw c.exception("access",'invalid attribute "'+a+'"');var e=d[a];"undefined"!==typeof b&&(d[a]=b);return e},invoke:function(a){if("undefined"===
typeof a)throw c.exception("invoke","no method name given");var b=this.obj();if(null===b)throw c.exception("invoke","still no object attached");if("undefined"===typeof b[a])throw c.exception("invoke",'invalid method "'+a+'"');if("function"!==c.istypeof(b[a]))throw c.exception("invoke",'anything named "'+a+'" existing, but not a function');var d=c.slice(arguments,1);return b[a].apply(b,d)}}});e.pattern.socket=e.trait({mixin:[e.pattern.tree,e.pattern.property],dynamics:{__plugs:{}},protos:{socket:function(){var a=
e.params("socket",arguments,{name:{def:"default"},scope:{def:null},ctx:{pos:0,def:null,req:!0},plug:{pos:1,def:null,req:!0},unplug:{pos:2,def:null,req:!0}});if("string"===c.istypeof(a.plug)&&"function"!==c.istypeof(a.ctx[a.plug]))throw c.exception("socket",'no plug method named "'+a.plug+'" found on context object');if("string"!==c.istypeof(a.plug)&&"function"!==c.istypeof(a.plug))throw c.exception("socket","plug operation neither method name nor function");if("string"===c.istypeof(a.unplug)&&"function"!==
c.istypeof(a.ctx[a.unplug]))throw c.exception("socket",'no unplug method named "'+a.unplug+'" found on context object');if("string"!==c.istypeof(a.unplug)&&"function"!==c.istypeof(a.unplug))throw c.exception("socket","unplug operation neither method name nor function");var b="ComponentJS:socket:"+a.name;null!==a.scope&&(b+="@"+a.scope);e(this).property(b,a)},link:function(){var a=e.params("link",arguments,{name:{def:"default"},scope:{def:null},target:{pos:0,req:!0},socket:{pos:1,req:!0}});this.socket({name:a.name,
scope:a.scope,ctx:{},plug:function(b){var d=c.annotation(b,"link");if(null!==d)throw c.exception("link:plug: cannot plug, you have to unplug first");d=e(a.target).plug({name:a.socket,object:b});c.annotation(b,"link",d)},unplug:function(b){var d=c.annotation(b,"link");if(null===d)throw c.exception("link:unplug: cannot unplug, you have to plug first");e(a.target).unplug(d);c.annotation(b,"link",null)}})},plug:function(){var a=e.params("plug",arguments,{name:{def:"default"},object:{pos:0,req:!0},spool:{def:null}}),
b=c.cid();this.__plugs[b]=a;c.plugger("plug",this,a.name,a.object);null!==a.spool&&this.spool(a.spool,this,"unplug",b);return b},unplug:function(){var a=e.params("unplug",arguments,{id:{pos:0,req:!0}});if("undefined"===typeof this.__plugs[a.id])throw c.exception("unplug","plugging not found");c.plugger("unplug",this,this.__plugs[a.id].name,this.__plugs[a.id].object);delete this.__plugs[a.id]}}});c.plugger=function(a,b,d,f){var g="ComponentJS:socket:"+d,h=b.property({name:g,targeting:!1});if(!c.isdefined(h))throw c.exception(a,
"no socket found on parent component(s)");g=b.property({name:g,targeting:!1,returnowner:!0});e.debug(1,"socket: "+g.path("/")+": "+d+" <--("+a+")-- "+b.path("/"));if("string"===c.istypeof(h[a]))h.ctx[h[a]].call(h.ctx,f);else if("function"===c.istypeof(h[a]))h[a].call(h.ctx,f);else throw c.exception(a,'failed to perform "'+a+'" operation');};e.pattern.hook=e.trait({mixin:[e.pattern.eventing],protos:{latch:function(){var a=e.params("latch",arguments,{name:{pos:0,def:null,req:!0},ctx:{def:this},func:{pos:1,
def:e.nop,req:!0},args:{pos:"...",def:[]},spool:{def:null}}),b=this.subscribe({name:"ComponentJS:hook:"+a.name,ctx:a.ctx,func:a.func,args:a.args,noevent:!0});null!==a.spool&&this.spool(a.spool,this,"unlatch",b);return b},unlatch:function(){var a=e.params("unlatch",arguments,{id:{pos:0,req:!0}});this.unsubscribe(a.id)},hook:function(){var a=e.params("hook",arguments,{name:{pos:0,def:null,req:!0},proc:{pos:1,def:"none",valid:function(a){return c.isdefined(c.hook_proc[a])}},args:{pos:"...",def:[]}});
return this.publish({name:"ComponentJS:hook:"+a.name,args:a.args,capturing:!1,spreading:!1,bubbling:!1,async:!1,resultinit:c.hook_proc[a.proc].init,resultstep:c.hook_proc[a.proc].step,directresult:!0})}}});e.mark=function(a,b){var d=c.annotation(a,"marker");null===d&&(d={});d[b]=!0;c.annotation(a,"marker",d)};e.marked=function(a,b){var d=c.annotation(a,"marker");null===d&&(d={});return!0===d[b]};e.pattern.marker=e.trait({protos:{mark:function(a){e.mark(this.obj(),a)},marked:function(a){return e.marked(this.obj(),
a)}}});e.marker={service:e.trait({cons:function(){e.mark(this,"service")}}),controller:e.trait({cons:function(){e.mark(this,"controller")}}),model:e.trait({cons:function(){e.mark(this,"model")}}),view:e.trait({cons:function(){e.mark(this,"view")}})};c.store_id=function(a){var b="ComponentJS:store:",b="undefined"!==typeof l.document&&"undefined"!==typeof l.document.location&&"string"===typeof l.document.location.pathname?b+l.document.location.pathname:b+"unknown-path";return b+=":"+a.path("/")};c.store_load=
function(a){if(null===a.__store){if("undefined"!==typeof l.localStorage&&"undefined"!==typeof l.JSON){var b=c.store_id(a),b=l.localStorage.getItem(b);"string"===typeof b&&(a.__store=l.JSON.parse(b))}if(null===a.__store||"object"!==typeof a.__store)a.__store={}}};c.store_save=function(a){if(null!==a.__store&&"undefined"!==typeof l.localStorage&&"undefined"!==typeof l.JSON){var b=c.store_id(a);a=l.JSON.stringify(a.__store);"{}"===a?l.localStorage.removeItem(b):l.localStorage.setItem(b,a)}};e.pattern.store=
e.trait({dynamics:{__store:null},protos:{store:function(){var a,b;if(0===arguments.length){c.store_load(this);b=[];for(a in this.__store)b.push(a);return b}if(1===arguments.length&&null===arguments[0])return this.__store={},c.store_save(this),null;if(1===arguments.length&&"string"===typeof arguments[0])return c.store_load(this),a=arguments[0],"undefined"===typeof this.__store[a]?null:this.__store[a];if(2===arguments.length&&null===arguments[1])return c.store_load(this),a=arguments[0],delete this.__store[a],
c.store_save(this),null;if(2===arguments.length)return c.store_load(this),a=arguments[0],b=arguments[1],this.__store[a]=b,c.store_save(this),b;throw c.exception("store","invalid argument(s)");}}});e.pattern.model=e.trait({protos:{model:function(a){var b;if(c.isdefined(a))for(b in a){"undefined"===typeof a[b].value&&(a[b].value="");"undefined"===typeof a[b].valid&&(a[b].valid="string");"undefined"===typeof a[b].autoreset&&(a[b].autoreset=!1);"undefined"===typeof a[b].store&&(a[b].store=!1);for(var d in a[b])if("value"!==
d&&"valid"!==d&&"autoreset"!==d&&"store"!==d)throw c.exception("model",'invalid specification key "'+d+'" in specification of model field "'+b+'"');if(!e.validate(a[b].value,a[b].valid))throw c.exception("model",'model field "'+b+'" has default value "'+a[b].value+'", which does not validate against validation "'+a[b].valid+'"');}var f=this.store("model");if(null!==f)for(b in a)a[b].store&&c.isdefined(f[b])&&(a[b].value=f[b]);d=this.property({name:"ComponentJS:model",bubbling:!1});if(c.isdefined(a)){c.isdefined(d)?
(f={},c.extend(f,d),c.extend(f,a),this.property("ComponentJS:model",f),a=f):this.property("ComponentJS:model",a);var f={},g=!1;for(b in a)a[b].store&&(f[b]=a[b].value,g=!0);g&&this.store("model",f)}return d},value:function(){for(var a=e.params("value",arguments,{name:{pos:0,def:null,req:!0},value:{pos:1,def:void 0},force:{pos:2,def:!1},returnowner:{def:!1}}),b=null,d=null,f=this;null!==f;){b=f.property({name:"ComponentJS:model",returnowner:!0});if(!c.isdefined(b))throw c.exception("value",'no model found containing value "'+
a.name+'"');d=b.property("ComponentJS:model");if(c.isdefined(d[a.name]))break;f=b.parent()}if(null===f)throw c.exception("value",'no model found containing value "'+a.name+'"');var f=a.value,g,h=d[a.name].value;"undefined"===typeof f&&!0===b.property({name:"ComponentJS:model:subscribers:get",bubbling:!1})&&(g=b.publish({name:"ComponentJS:model:"+a.name+":get",args:[h],capturing:!1,spreading:!1,bubbling:!1,async:!1}),g.processing()&&(h=d[a.name].value,g=g.result(),"undefined"!==typeof g&&(h=g)));if("undefined"!==
typeof f&&(a.force||h!==f)){if(!e.validate(f,d[a.name].valid))throw c.exception("value",'invalid value "'+f+'" for model field "'+a.name+'"');var j=!0;!0===b.property({name:"ComponentJS:model:subscribers:set",bubbling:!1})&&(g=b.publish({name:"ComponentJS:model:"+a.name+":set",args:[f,h],capturing:!1,spreading:!1,bubbling:!1,async:!1}),g.processing()?(g=g.result(),"undefined"!==typeof g&&(f=g)):j=!1);j&&!d[a.name].autoreset&&(d[a.name].value=f,d[a.name].store&&(j=b.store("model"),j[a.name]=d[a.name].value,
b.store("model",j)),!0===b.property({name:"ComponentJS:model:subscribers:changed",bubbling:!1})&&b.publish({name:"ComponentJS:model:"+a.name+":changed",args:[f,h],noresult:!0,capturing:!1,spreading:!1,bubbling:!1,async:!1}))}return a.returnowner?b:h},touch:function(){var a=e.params("touch",arguments,{name:{pos:0,req:!0}});this.value({name:a.name,value:this.value(a.name),force:!0})},observe:function(){for(var a=e.params("observe",arguments,{name:{pos:0,req:!0},func:{pos:1,req:!0},touch:{def:!1},operation:{def:"set"},
spool:{def:null}}),b=null,d=null,f=this;null!==f;){b=f.property({name:"ComponentJS:model",returnowner:!0});if(!c.isdefined(b))throw c.exception("observe",'no model found containing value "'+a.name+'"');d=b.property("ComponentJS:model");if(c.isdefined(d[a.name]))break;f=b.parent()}if(null===f)throw c.exception("observe",'no model found containing value "'+a.name+'"');d=b.subscribe({name:"ComponentJS:model:"+a.name+":"+a.operation,capturing:!1,spreading:!1,bubbling:!1,func:a.func});b.property("ComponentJS:model:subscribers:"+
a.operation,!0);null!==a.spool&&this.spool(a.spool,this,"unobserve",d);a.touch&&this.touch(a.name);return d},unobserve:function(){for(var a=e.params("unobserve",arguments,{id:{pos:0,req:!0}}),b=null,d=this;null!==d;){b=d.property({name:"ComponentJS:model",returnowner:!0});if(!c.isdefined(b))throw c.exception("unobserve","no model subscription found");if(b.subscription(a.id))break;d=b.parent()}if(null===d)throw c.exception("unobserve","no model subscription found");b.unsubscribe(a.id)}}});c.comp=null;
c.none=null;c.root=null;c.comp_mixins=[e.pattern.id,e.pattern.name,e.pattern.tree,e.pattern.config,e.pattern.spool,e.pattern.state,e.pattern.service,e.pattern.eventing,e.pattern.property,e.pattern.shadow,e.pattern.socket,e.pattern.model,e.pattern.store,e.pattern.marker];c.comp_cons=function(a,b,d){c.annotation(this,"type","component");"string"!==c.istypeof(a)&&(a="<unknown>");this.name(a);this.parent("object"===c.istypeof(b)?b:null);this.children("array"===c.istypeof(d)?d:[])};c.comp_protos={create:function(){return e.create.apply(this,
c.concat([this],arguments))},destroy:function(){return e.destroy.apply(this,c.concat([this],arguments))},exists:function(){return"<none>"!==this.name()}};c.bootstrapped=!1;e.bootstrap=function(){if(c.bootstrapped)throw c.exception("bootstrap","library already bootstrapped");c.hook("ComponentJS:bootstrap:comp:mixin","none",c.comp_mixins);c.hook("ComponentJS:bootstrap:comp:protos","none",c.comp_protos);c.comp=e.clazz({mixin:c.comp_mixins,cons:c.comp_cons,protos:c.comp_protos});c.root=new c.comp("<root>",
null,[]);c.none=new c.comp("<none>",null,[]);c.foreach("call callable create destroy guard hook invoke latch link model observe plug property publish register registration socket spool spooled state state_compare store subscribe subscription touch unlatch unobserve unplug unregister unspool unsubscribe value".split(" "),function(a){c.none[a]=function(){throw c.exception(a,'no such component (you are calling method "'+a+'" on component "<none>")');}});c.hook("ComponentJS:bootstrap","none");c.bootstrapped=
!0};e.shutdown=function(){if(!c.bootstrapped)throw c.exception("shutdown","library still not bootstrapped");c.hook("ComponentJS:shutdown","none");c.none=null;c.root.destroy();c.root=null;c.comp=null;c.bootstrapped=!1};c.lookup=function(a,b){1===arguments.length&&("string"===c.istypeof(arguments[0])?(b=a,a=c.root):b="");if("string"!==typeof b)return c.none;if("<root>"===b)return c.root;if("<none>"===b)return c.none;var d;if("/"===b.substr(0,1))d=c.root,b=b.substring(1);else{d=c.istypeof(a);var e=c.annotation(a,
"comp");if("component"!==d&&null!==e)d=e;else{if("component"!==d)throw c.exception("lookup",'invalid base component (type is "'+d+'")');d=a}}if(""!==b)if(e=[],c.lookup_step(e,d,b.split("/"),0),0===e.length)d=c.none;else if(1===e.length)d=e[0];else{var g={},e=c.filter(e,function(a){a=a.id();var b="undefined"===typeof g[a];g[a]=!0;return b});if(1===e.length)d=e[0];else{for(var h="",j=0;j<e.length;j++)h+=" "+e[j].path("/");throw c.exception("lookup",'ambiguous component path "'+b+'" at '+d.path("/")+
": expected only 1 component, but found "+e.length+" components:"+h);}}return d};c.lookup_step=function(a,b,d,e){var g;if(e>=d.length)a.push(b);else if("."===d[e])c.lookup_step(a,b,d,e+1);else if(".."===d[e])null!==b.parent()&&c.lookup_step(a,b.parent(),d,e+1);else if("*"===d[e]){g=b.children();for(b=0;b<g.length;b++)c.lookup_step(a,g[b],d,e+1)}else if(""===d[e]){g=b.walk_down(function(a,b,c,d){d||c.push(b);return c},[]);for(b=0;b<g.length;b++)c.lookup_step(a,g[b],d,e+1)}else{g=b.children();for(b=
0;b<g.length;b++)if(g[b].name()===d[e]){c.lookup_step(a,g[b],d,e+1);break}}};e.create=function(){c.bootstrapped||(alert('WARNING: ComponentJS still not bootstrapped (please call "bootstrap" method before first "create" method call!)'),e.bootstrap());if(2>arguments.length)throw c.exception("create","invalid number of arguments");var a=0,b=null,d=null,f=[];if("string"===c.istypeof(arguments[a])){if("/"!==arguments[a].substr(0,1))throw c.exception("create",'either base component has to be given or the tree specification has to start with the root component ("/")');
b=c.root}else if(d=arguments[a++],"component"!==c.istypeof(d)&&(d=c.annotation(d,"comp"),null===d))throw c.exception("create","invalid base argument (not an object attached to a component)");for(var g=[],h=arguments[a++],j;""!==h;){j=h.match(/^\s*([^\/{},]+|[\/{},])/);if(null===j)break;g.push(j[1]);h=h.substr(j[1].length)}h=function(a,b){for(var c="",d=0;d<b&&d<a.length;d++)c+=a[d];if(d<a.length){c=c+"<"+a[d++];for(c+=">";d<a.length;d++)c+=a[d]}return c};for(j=0;j<g.length;j++)if("/"===g[j]){if(null===
b)throw c.exception("create","no parent component for step-down at "+h(g,j));d=b}else if("{"===g[j])f.push(d);else if(","===g[j]){if(0===f.length)throw c.exception("create","no open brace section for parallelism at "+h(g,j));d=f[f.length-1]}else if("}"===g[j]){if(0===f.length)throw c.exception("create","no more open brace section for closing at "+h(g,j));d=f.pop();b=null}else{if(null===d)throw c.exception("create","no base component at "+h(g,j));b=c.create_single(d,g[j],arguments[a++])}if(0<f.length)throw c.exception("create",
"still open brace sections at end of tree specification");return b};c.create_single=function(a,b,d){if("string"!==typeof b)throw c.exception("create","invalid path argument (not a string)");var f=b.match(/^(.*?)\/?([^\/]+)$/);if(!f[0])throw c.exception("create",'invalid path "'+b+'"');var g=f[1],f=f[2];b=c.cid();f=f.replace(/\{id\}/g,b);a=c.lookup(a,g);if(a===c.none)throw c.exception("create",'parent component path "'+g+'" not already existing (please create first)');g=c.lookup(a,f);if(g!==c.none)throw c.exception("create",
'leaf component path "'+f+'" already existing (please destroy first)');var h=null;switch(c.istypeof(d)){case "clazz":case "trait":case "function":h=new d;break;case "object":h=d;break;case "null":break;default:throw c.exception("create","invalid class argument");}g=new c.comp(f);g.id(b);g._attach(a);g.obj(h);e.debug(1,"component: "+g.path("/")+": created component ["+g.id()+"]");g.state({state:"created",sync:!0});c.hook("ComponentJS:state-invalidate","none","components");c.hook("ComponentJS:state-change",
"none");return g};e.destroy=function(){if(1!==arguments.length&&2!==arguments.length)throw c.exception("destroy","invalid number of arguments");var a=c.lookup.apply(this,arguments);if(a===c.none)throw c.exception("destroy","no such component found to destroy");if(a===c.root)throw c.exception("destroy","root component cannot be destroyed");a.state({state:"dead",sync:!0});a._detach();a.obj(null);e.debug(1,"component: "+a.path("/")+": destroyed component ["+a.id()+"]");c.hook("ComponentJS:state-invalidate",
"none","components");c.hook("ComponentJS:state-change","none")};e.transition=function(){if(1===arguments.length&&null===arguments[0])c.states_clear();else{var a=e.params("transition",arguments,{target:{pos:0,def:null,req:!0},enter:{pos:1,def:null,req:!0},leave:{pos:2,def:null,req:!0},color:{pos:3,def:null,req:!0},source:{def:null}});c.states_add(a.target,a.enter,a.leave,a.color,a.source)}};e.transition("created","create","destroy","#cc3333");e.transition("configured","setup","teardown","#eabc43");
e.transition("prepared","prepare","cleanup","#f2ec00");e.transition("materialized","render","release","#6699cc");e.transition("visible","show","hide","#669933");"object"===typeof u&&"undefined"===typeof l.ComponentJS_export||"undefined"!==typeof l.ComponentJS_export&&"CommonJS"===l.ComponentJS_export?u.ComponentJS=e:"function"===typeof p&&"object"===typeof p.amd&&"undefined"===typeof l.ComponentJS_export||"undefined"!==typeof l.ComponentJS_export&&"AMD"===l.ComponentJS_export?p("ComponentJS",function(){return e}):
e.symbol("ComponentJS");c.plugins={};e.plugin=function(a,b){if(0===arguments.length){var d=[];for(a in c.plugins)c.isown(c.plugins,a)&&d.push(a);return d}if(1===arguments.length){if("string"!==typeof a)throw c.exception("plugin","invalid plugin name parameter");return"undefined"!==typeof c.plugins[a]}if(2===arguments.length){if("string"!==typeof a)throw c.exception("plugin","invalid plugin name parameter");if("undefined"!==typeof c.plugins[a])throw c.exception("plugin",'plugin named "'+a+'" already registered');
b.call(this,c,e,l);c.plugins[a]=!0}else throw c.exception("plugin","invalid number of parameters");}})("undefined"!==typeof window?window:"undefined"!==typeof global?global:"undefined"!==typeof this?this:{},"object"===typeof exports?exports:void 0,"function"===typeof define?define:void 0);
